/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a resource type.
    /// </summary>
    [DataContract(Name = "ResourceTypeDto")]
    public partial class ResourceTypeDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceTypeDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ResourceTypeDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceTypeDto" /> class.
        /// </summary>
        /// <param name="id">The unique identifier of the resource type..</param>
        /// <param name="generalType">The general type of the resource. (required).</param>
        /// <param name="specificType">The specific type of the resource. (required).</param>
        /// <param name="options">options.</param>
        public ResourceTypeDto(Guid id = default(Guid), string generalType = default(string), string specificType = default(string), ResourceTypeOptionsDto options = default(ResourceTypeOptionsDto))
        {
            // to ensure "generalType" is required (not null)
            if (generalType == null)
            {
                throw new ArgumentNullException("generalType is a required property for ResourceTypeDto and cannot be null");
            }
            this.GeneralType = generalType;
            // to ensure "specificType" is required (not null)
            if (specificType == null)
            {
                throw new ArgumentNullException("specificType is a required property for ResourceTypeDto and cannot be null");
            }
            this.SpecificType = specificType;
            this.Id = id;
            this.Options = options;
        }

        /// <summary>
        /// The unique identifier of the resource type.
        /// </summary>
        /// <value>The unique identifier of the resource type.</value>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public Guid Id { get; set; }

        /// <summary>
        /// The general type of the resource.
        /// </summary>
        /// <value>The general type of the resource.</value>
        [DataMember(Name = "generalType", IsRequired = true, EmitDefaultValue = true)]
        public string GeneralType { get; set; }

        /// <summary>
        /// The specific type of the resource.
        /// </summary>
        /// <value>The specific type of the resource.</value>
        [DataMember(Name = "specificType", IsRequired = true, EmitDefaultValue = true)]
        public string SpecificType { get; set; }

        /// <summary>
        /// Gets or Sets Options
        /// </summary>
        [DataMember(Name = "options", EmitDefaultValue = false)]
        public ResourceTypeOptionsDto Options { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceTypeDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  GeneralType: ").Append(GeneralType).Append("\n");
            sb.Append("  SpecificType: ").Append(SpecificType).Append("\n");
            sb.Append("  Options: ").Append(Options).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
